use std::time::Instant;
use itertools::Itertools;

enum Direction{
    North,
    South,
    East,
    West
}
pub fn execute_task01(content: &str) {
    let start = Instant::now();
    let gravity_1 = solve_01(content).unwrap();
    let duration = start.elapsed();

    //assert_eq!(10165598, gravity_1);
    println!("Day14 - Task01 - Duration: {duration:?} - One time gravity: {}", gravity_1)
}

pub fn execute_task02(content: &str) {
    let start = Instant::now();
    let gravity_1000000 = solve_02(content).unwrap();
    let duration = start.elapsed();

    //assert_eq!(678728808158, gravity_1000000);
    println!("Day14 - Task02 - Duration: {duration:?} - 1 Million time gravity: {}", gravity_1000000)
}


fn solve_01(content: &str) -> anyhow::Result<usize> {
    let map = content
        .lines()
        .map(|chars| chars.chars().collect_vec())
        .collect_vec();




    todo!()
}

fn solve_02(content: &str) -> anyhow::Result<usize> {
    todo!()
}

fn move_direction(map: &Vec<Vec<char>>, direction: Direction) {
    match direction {
        Direction::North => {
            let mut stones = vec![0; map.len()];

            for row in 0..map.len() {
                let width = map[row].len();
                for col in 0..width {
                    let char = map[row][col].clone();

                    match char {
                        '0' => {
                            if stones[col] != row - 1 {

                            }
                        },
                        '#' => stones[col] = row,
                        '.' => (),
                        _ => unreachable!()
                    };
                }
            }


        }
        Direction::South => {}
        Direction::East => {}
        Direction::West => {}
    }
}


#[test]
fn test_solve_01() {
    let example = r#"O....#....
O.OO#....#
.....##...
OO.#O....O
.O.....O#.
O.#..O.#.#
..O..#O..O
.......O..
#....###..
#OO..#...."#;

    let result = solve_01(example).unwrap();

    assert_eq!(136, result);
}

#[test]
fn test_solve_02() {
    let example = r#"...#......
.......#..
#.........
..........
......#...
.#........
.........#
..........
.......#..
#...#....."#;

    let result = solve_02(example).unwrap();

    assert_eq!(1030, result);
}
