mod day01;
mod utils;
mod day02;
mod day03;
mod day04;
mod day05;
mod day06;
mod day07;
mod day08;
mod day09;
mod day10;
mod day11;
mod day14;
mod day15;

const CONTENT01: &'static str = include_str!("input/day01/input.txt");
const CONTENT02: &'static str = include_str!("input/day02/input.txt");
const CONTENT03: &'static str = include_str!("input/day03/input.txt");
const CONTENT04: &'static str = include_str!("input/day04/input.txt");
const CONTENT05: &'static str = include_str!("input/day05/input.txt");
const CONTENT06: &'static str = include_str!("input/day06/input.txt");
const CONTENT07: &'static str = include_str!("input/day07/input.txt");
const CONTENT08: &'static str = include_str!("input/day08/input.txt");
const CONTENT09: &'static str = include_str!("input/day09/input.txt");
const CONTENT10: &'static str = include_str!("input/day10/input.txt");
const CONTENT11: &'static str = include_str!("input/day11/input.txt");
const CONTENT14: &'static str = include_str!("input/day14/input.txt");
const CONTENT15: &'static str = include_str!("input/day15/input.txt");

fn main() {
    day01::execute_task01(CONTENT01);
    day01::execute_task02(CONTENT01);
    println!();
    day02::execute_task01(CONTENT02);
    day02::execute_task02(CONTENT02);
    println!();
    day03::execute_task01(CONTENT03);
    day03::execute_task02(CONTENT03);
    println!();
    day04::execute_task01(CONTENT04);
    day04::execute_task02(CONTENT04);
    println!();
    day05::execute_task01(CONTENT05);
    //day05::execute_task02(CONTENT05); // Performance Issues
    println!();
    day06::execute_task01(CONTENT06);
    day06::execute_task02(CONTENT06);
    println!();
    day07::execute_task01(CONTENT07);
    day07::execute_task02(CONTENT07);
    println!();
    day08::execute_task01(CONTENT08);
    day08::execute_task02(CONTENT08);
    println!();
    day09::execute_task01(CONTENT09);
    day09::execute_task02(CONTENT09);
    println!();
    day10::execute_task01(CONTENT10);
    day10::execute_task02(CONTENT10);
    println!();
    day11::execute_task01(CONTENT11);
    day11::execute_task02(CONTENT11);
    println!();
    day15::execute_task01(CONTENT15);
    day15::execute_task02(CONTENT15);
}
